#include "TROOT.h"
#include <string>
#include <string>
#include <fstream> 
#include <iostream> 

using namespace std;

class straw_muon_lib 
{
  public:
    static double Theta[1200];
    static double Prob[80][1200];
    straw_muon_lib()
    {
      std::ifstream MSlibrary;
      int j,k;
      double prob,msNcount[80][1200],msN[80];
      char *filein[] = {"/afs/cern.ch/na48/user/ruggierg/geant4/mslibrary/muon_500.db",
                        "/afs/cern.ch/na48/user/ruggierg/geant4/mslibrary/muon_1500.db",
                        "/afs/cern.ch/na48/user/ruggierg/geant4/mslibrary/muon_2500.db",
                        "/afs/cern.ch/na48/user/ruggierg/geant4/mslibrary/muon_3500.db",
                        "/afs/cern.ch/na48/user/ruggierg/geant4/mslibrary/muon_4500.db",
                        "/afs/cern.ch/na48/user/ruggierg/geant4/mslibrary/muon_5500.db",
                        "/afs/cern.ch/na48/user/ruggierg/geant4/mslibrary/muon_6500.db",
                        "/afs/cern.ch/na48/user/ruggierg/geant4/mslibrary/muon_7500.db",
                        "/afs/cern.ch/na48/user/ruggierg/geant4/mslibrary/muon_8500.db",
                        "/afs/cern.ch/na48/user/ruggierg/geant4/mslibrary/muon_9500.db",
                        "/afs/cern.ch/na48/user/ruggierg/geant4/mslibrary/muon_10500.db",
                        "/afs/cern.ch/na48/user/ruggierg/geant4/mslibrary/muon_11500.db",
                        "/afs/cern.ch/na48/user/ruggierg/geant4/mslibrary/muon_12500.db",
                        "/afs/cern.ch/na48/user/ruggierg/geant4/mslibrary/muon_13500.db",
                        "/afs/cern.ch/na48/user/ruggierg/geant4/mslibrary/muon_14500.db",
                        "/afs/cern.ch/na48/user/ruggierg/geant4/mslibrary/muon_15500.db",
                        "/afs/cern.ch/na48/user/ruggierg/geant4/mslibrary/muon_16500.db",
                        "/afs/cern.ch/na48/user/ruggierg/geant4/mslibrary/muon_17500.db",
                        "/afs/cern.ch/na48/user/ruggierg/geant4/mslibrary/muon_18500.db",
                        "/afs/cern.ch/na48/user/ruggierg/geant4/mslibrary/muon_19500.db",
                        "/afs/cern.ch/na48/user/ruggierg/geant4/mslibrary/muon_20500.db",
                        "/afs/cern.ch/na48/user/ruggierg/geant4/mslibrary/muon_21500.db",
                        "/afs/cern.ch/na48/user/ruggierg/geant4/mslibrary/muon_22500.db",
                        "/afs/cern.ch/na48/user/ruggierg/geant4/mslibrary/muon_23500.db",
                        "/afs/cern.ch/na48/user/ruggierg/geant4/mslibrary/muon_24500.db",
                        "/afs/cern.ch/na48/user/ruggierg/geant4/mslibrary/muon_25500.db",
                        "/afs/cern.ch/na48/user/ruggierg/geant4/mslibrary/muon_26500.db",
                        "/afs/cern.ch/na48/user/ruggierg/geant4/mslibrary/muon_27500.db",
                        "/afs/cern.ch/na48/user/ruggierg/geant4/mslibrary/muon_28500.db",
                        "/afs/cern.ch/na48/user/ruggierg/geant4/mslibrary/muon_29500.db",
                        "/afs/cern.ch/na48/user/ruggierg/geant4/mslibrary/muon_30500.db",
                        "/afs/cern.ch/na48/user/ruggierg/geant4/mslibrary/muon_31500.db",
                        "/afs/cern.ch/na48/user/ruggierg/geant4/mslibrary/muon_32500.db",
                        "/afs/cern.ch/na48/user/ruggierg/geant4/mslibrary/muon_33500.db",
                        "/afs/cern.ch/na48/user/ruggierg/geant4/mslibrary/muon_34500.db",
                        "/afs/cern.ch/na48/user/ruggierg/geant4/mslibrary/muon_35500.db",
                        "/afs/cern.ch/na48/user/ruggierg/geant4/mslibrary/muon_36500.db",
                        "/afs/cern.ch/na48/user/ruggierg/geant4/mslibrary/muon_37500.db",
                        "/afs/cern.ch/na48/user/ruggierg/geant4/mslibrary/muon_38500.db",
                        "/afs/cern.ch/na48/user/ruggierg/geant4/mslibrary/muon_39500.db",
                        "/afs/cern.ch/na48/user/ruggierg/geant4/mslibrary/muon_40500.db",
                        "/afs/cern.ch/na48/user/ruggierg/geant4/mslibrary/muon_41500.db",
                        "/afs/cern.ch/na48/user/ruggierg/geant4/mslibrary/muon_42500.db",
                        "/afs/cern.ch/na48/user/ruggierg/geant4/mslibrary/muon_43500.db",
                        "/afs/cern.ch/na48/user/ruggierg/geant4/mslibrary/muon_44500.db",
                        "/afs/cern.ch/na48/user/ruggierg/geant4/mslibrary/muon_45500.db",
                        "/afs/cern.ch/na48/user/ruggierg/geant4/mslibrary/muon_46500.db",
                        "/afs/cern.ch/na48/user/ruggierg/geant4/mslibrary/muon_47500.db",
                        "/afs/cern.ch/na48/user/ruggierg/geant4/mslibrary/muon_48500.db",
                        "/afs/cern.ch/na48/user/ruggierg/geant4/mslibrary/muon_49500.db",
                        "/afs/cern.ch/na48/user/ruggierg/geant4/mslibrary/muon_50500.db",
                        "/afs/cern.ch/na48/user/ruggierg/geant4/mslibrary/muon_51500.db",
                        "/afs/cern.ch/na48/user/ruggierg/geant4/mslibrary/muon_52500.db",
                        "/afs/cern.ch/na48/user/ruggierg/geant4/mslibrary/muon_53500.db",
                        "/afs/cern.ch/na48/user/ruggierg/geant4/mslibrary/muon_54500.db",
                        "/afs/cern.ch/na48/user/ruggierg/geant4/mslibrary/muon_55500.db",
                        "/afs/cern.ch/na48/user/ruggierg/geant4/mslibrary/muon_56500.db",
                        "/afs/cern.ch/na48/user/ruggierg/geant4/mslibrary/muon_57500.db",
                        "/afs/cern.ch/na48/user/ruggierg/geant4/mslibrary/muon_58500.db",
                        "/afs/cern.ch/na48/user/ruggierg/geant4/mslibrary/muon_59500.db",
                        "/afs/cern.ch/na48/user/ruggierg/geant4/mslibrary/muon_60500.db",
                        "/afs/cern.ch/na48/user/ruggierg/geant4/mslibrary/muon_61500.db",
                        "/afs/cern.ch/na48/user/ruggierg/geant4/mslibrary/muon_62500.db",
                        "/afs/cern.ch/na48/user/ruggierg/geant4/mslibrary/muon_63500.db",
                        "/afs/cern.ch/na48/user/ruggierg/geant4/mslibrary/muon_64500.db",
                        "/afs/cern.ch/na48/user/ruggierg/geant4/mslibrary/muon_65500.db",
                        "/afs/cern.ch/na48/user/ruggierg/geant4/mslibrary/muon_66500.db",
                        "/afs/cern.ch/na48/user/ruggierg/geant4/mslibrary/muon_67500.db",
                        "/afs/cern.ch/na48/user/ruggierg/geant4/mslibrary/muon_68500.db",
                        "/afs/cern.ch/na48/user/ruggierg/geant4/mslibrary/muon_69500.db",
                        "/afs/cern.ch/na48/user/ruggierg/geant4/mslibrary/muon_70500.db",
                        "/afs/cern.ch/na48/user/ruggierg/geant4/mslibrary/muon_71500.db",
                        "/afs/cern.ch/na48/user/ruggierg/geant4/mslibrary/muon_72500.db",
                        "/afs/cern.ch/na48/user/ruggierg/geant4/mslibrary/muon_73500.db",
                        "/afs/cern.ch/na48/user/ruggierg/geant4/mslibrary/muon_74500.db",
                        "/afs/cern.ch/na48/user/ruggierg/geant4/mslibrary/muon_75500.db",
                        "/afs/cern.ch/na48/user/ruggierg/geant4/mslibrary/muon_76500.db",
                        "/afs/cern.ch/na48/user/ruggierg/geant4/mslibrary/muon_77500.db",
                        "/afs/cern.ch/na48/user/ruggierg/geant4/mslibrary/muon_78500.db",
                        "/afs/cern.ch/na48/user/ruggierg/geant4/mslibrary/muon_79500.db"};
      for (j=0;j<80;j++)
      {
        msN[j] = 0;
        MSlibrary.open(filein[j],ios::in);
        for (k=0;k<1200;k++)
        {
          MSlibrary >> Theta[k] >> msNcount[j][k];
          msN[j] += msNcount[j][k];
        }
        MSlibrary.close();
      }
      for (j=0;j<80;j++)
      {
        prob = 0;
        if (!msN[j]) continue;
        for (k=0;k<1200;k++)
        {
          Prob[j][1199-k] = 1.-prob;
          prob += msNcount[j][1199-k]/msN[j];
        }
      }
      cout << "Muon MS library for Straw Chambers Loaded" << endl;
    }
   ~straw_muon_lib(){}
};
