#include "TROOT.h"
#include <string>
#include <string>
#include <fstream> 
#include <iostream> 

using namespace std;

class straw_positron_lib 
{
  public:
    static double Theta[1200];
    static double Prob[80][1200];
    straw_positron_lib()
    {
      std::ifstream MSlibrary;
      int j,k;
      double prob,msNcount[80][1200],msN[80];
      char *filein[] = {"/afs/cern.ch/na48/user/ruggierg/geant4/mslibrary/positron_500.db",
                        "/afs/cern.ch/na48/user/ruggierg/geant4/mslibrary/positron_1500.db",
                        "/afs/cern.ch/na48/user/ruggierg/geant4/mslibrary/positron_2500.db",
                        "/afs/cern.ch/na48/user/ruggierg/geant4/mslibrary/positron_3500.db",
                        "/afs/cern.ch/na48/user/ruggierg/geant4/mslibrary/positron_4500.db",
                        "/afs/cern.ch/na48/user/ruggierg/geant4/mslibrary/positron_5500.db",
                        "/afs/cern.ch/na48/user/ruggierg/geant4/mslibrary/positron_6500.db",
                        "/afs/cern.ch/na48/user/ruggierg/geant4/mslibrary/positron_7500.db",
                        "/afs/cern.ch/na48/user/ruggierg/geant4/mslibrary/positron_8500.db",
                        "/afs/cern.ch/na48/user/ruggierg/geant4/mslibrary/positron_9500.db",
                        "/afs/cern.ch/na48/user/ruggierg/geant4/mslibrary/positron_10500.db",
                        "/afs/cern.ch/na48/user/ruggierg/geant4/mslibrary/positron_11500.db",
                        "/afs/cern.ch/na48/user/ruggierg/geant4/mslibrary/positron_12500.db",
                        "/afs/cern.ch/na48/user/ruggierg/geant4/mslibrary/positron_13500.db",
                        "/afs/cern.ch/na48/user/ruggierg/geant4/mslibrary/positron_14500.db",
                        "/afs/cern.ch/na48/user/ruggierg/geant4/mslibrary/positron_15500.db",
                        "/afs/cern.ch/na48/user/ruggierg/geant4/mslibrary/positron_16500.db",
                        "/afs/cern.ch/na48/user/ruggierg/geant4/mslibrary/positron_17500.db",
                        "/afs/cern.ch/na48/user/ruggierg/geant4/mslibrary/positron_18500.db",
                        "/afs/cern.ch/na48/user/ruggierg/geant4/mslibrary/positron_19500.db",
                        "/afs/cern.ch/na48/user/ruggierg/geant4/mslibrary/positron_20500.db",
                        "/afs/cern.ch/na48/user/ruggierg/geant4/mslibrary/positron_21500.db",
                        "/afs/cern.ch/na48/user/ruggierg/geant4/mslibrary/positron_22500.db",
                        "/afs/cern.ch/na48/user/ruggierg/geant4/mslibrary/positron_23500.db",
                        "/afs/cern.ch/na48/user/ruggierg/geant4/mslibrary/positron_24500.db",
                        "/afs/cern.ch/na48/user/ruggierg/geant4/mslibrary/positron_25500.db",
                        "/afs/cern.ch/na48/user/ruggierg/geant4/mslibrary/positron_26500.db",
                        "/afs/cern.ch/na48/user/ruggierg/geant4/mslibrary/positron_27500.db",
                        "/afs/cern.ch/na48/user/ruggierg/geant4/mslibrary/positron_28500.db",
                        "/afs/cern.ch/na48/user/ruggierg/geant4/mslibrary/positron_29500.db",
                        "/afs/cern.ch/na48/user/ruggierg/geant4/mslibrary/positron_30500.db",
                        "/afs/cern.ch/na48/user/ruggierg/geant4/mslibrary/positron_31500.db",
                        "/afs/cern.ch/na48/user/ruggierg/geant4/mslibrary/positron_32500.db",
                        "/afs/cern.ch/na48/user/ruggierg/geant4/mslibrary/positron_33500.db",
                        "/afs/cern.ch/na48/user/ruggierg/geant4/mslibrary/positron_34500.db",
                        "/afs/cern.ch/na48/user/ruggierg/geant4/mslibrary/positron_35500.db",
                        "/afs/cern.ch/na48/user/ruggierg/geant4/mslibrary/positron_36500.db",
                        "/afs/cern.ch/na48/user/ruggierg/geant4/mslibrary/positron_37500.db",
                        "/afs/cern.ch/na48/user/ruggierg/geant4/mslibrary/positron_38500.db",
                        "/afs/cern.ch/na48/user/ruggierg/geant4/mslibrary/positron_39500.db",
                        "/afs/cern.ch/na48/user/ruggierg/geant4/mslibrary/positron_40500.db",
                        "/afs/cern.ch/na48/user/ruggierg/geant4/mslibrary/positron_41500.db",
                        "/afs/cern.ch/na48/user/ruggierg/geant4/mslibrary/positron_42500.db",
                        "/afs/cern.ch/na48/user/ruggierg/geant4/mslibrary/positron_43500.db",
                        "/afs/cern.ch/na48/user/ruggierg/geant4/mslibrary/positron_44500.db",
                        "/afs/cern.ch/na48/user/ruggierg/geant4/mslibrary/positron_45500.db",
                        "/afs/cern.ch/na48/user/ruggierg/geant4/mslibrary/positron_46500.db",
                        "/afs/cern.ch/na48/user/ruggierg/geant4/mslibrary/positron_47500.db",
                        "/afs/cern.ch/na48/user/ruggierg/geant4/mslibrary/positron_48500.db",
                        "/afs/cern.ch/na48/user/ruggierg/geant4/mslibrary/positron_49500.db",
                        "/afs/cern.ch/na48/user/ruggierg/geant4/mslibrary/positron_50500.db",
                        "/afs/cern.ch/na48/user/ruggierg/geant4/mslibrary/positron_51500.db",
                        "/afs/cern.ch/na48/user/ruggierg/geant4/mslibrary/positron_52500.db",
                        "/afs/cern.ch/na48/user/ruggierg/geant4/mslibrary/positron_53500.db",
                        "/afs/cern.ch/na48/user/ruggierg/geant4/mslibrary/positron_54500.db",
                        "/afs/cern.ch/na48/user/ruggierg/geant4/mslibrary/positron_55500.db",
                        "/afs/cern.ch/na48/user/ruggierg/geant4/mslibrary/positron_56500.db",
                        "/afs/cern.ch/na48/user/ruggierg/geant4/mslibrary/positron_57500.db",
                        "/afs/cern.ch/na48/user/ruggierg/geant4/mslibrary/positron_58500.db",
                        "/afs/cern.ch/na48/user/ruggierg/geant4/mslibrary/positron_59500.db",
                        "/afs/cern.ch/na48/user/ruggierg/geant4/mslibrary/positron_60500.db",
                        "/afs/cern.ch/na48/user/ruggierg/geant4/mslibrary/positron_61500.db",
                        "/afs/cern.ch/na48/user/ruggierg/geant4/mslibrary/positron_62500.db",
                        "/afs/cern.ch/na48/user/ruggierg/geant4/mslibrary/positron_63500.db",
                        "/afs/cern.ch/na48/user/ruggierg/geant4/mslibrary/positron_64500.db",
                        "/afs/cern.ch/na48/user/ruggierg/geant4/mslibrary/positron_65500.db",
                        "/afs/cern.ch/na48/user/ruggierg/geant4/mslibrary/positron_66500.db",
                        "/afs/cern.ch/na48/user/ruggierg/geant4/mslibrary/positron_67500.db",
                        "/afs/cern.ch/na48/user/ruggierg/geant4/mslibrary/positron_68500.db",
                        "/afs/cern.ch/na48/user/ruggierg/geant4/mslibrary/positron_69500.db",
                        "/afs/cern.ch/na48/user/ruggierg/geant4/mslibrary/positron_70500.db",
                        "/afs/cern.ch/na48/user/ruggierg/geant4/mslibrary/positron_71500.db",
                        "/afs/cern.ch/na48/user/ruggierg/geant4/mslibrary/positron_72500.db",
                        "/afs/cern.ch/na48/user/ruggierg/geant4/mslibrary/positron_73500.db",
                        "/afs/cern.ch/na48/user/ruggierg/geant4/mslibrary/positron_74500.db",
                        "/afs/cern.ch/na48/user/ruggierg/geant4/mslibrary/positron_75500.db",
                        "/afs/cern.ch/na48/user/ruggierg/geant4/mslibrary/positron_76500.db",
                        "/afs/cern.ch/na48/user/ruggierg/geant4/mslibrary/positron_77500.db",
                        "/afs/cern.ch/na48/user/ruggierg/geant4/mslibrary/positron_78500.db",
                        "/afs/cern.ch/na48/user/ruggierg/geant4/mslibrary/positron_79500.db"};
      for (j=0;j<80;j++)
      {
        msN[j] = 0;
        MSlibrary.open(filein[j],ios::in);
        for (k=0;k<1200;k++)
        {
          MSlibrary >> Theta[k] >> msNcount[j][k];
          msN[j] += msNcount[j][k];
        }
        MSlibrary.close();
      }
      for (j=0;j<80;j++)
      {
        prob = 0;
        if (!msN[j]) continue;
        for (k=0;k<1200;k++)
        {
          Prob[j][1199-k] = 1.-prob;
          prob += msNcount[j][1199-k]/msN[j];
        }
      }
      cout << "Positron MS library for Straw Chambers Loaded" << endl;
    }
   ~straw_positron_lib(){}
};
