#include "TROOT.h"
#include <string>
#include <string>
#include <fstream> 
#include <iostream> 

using namespace std;

class straw_pplus_lib 
{
  public:
    static double Theta[1200];
    static double Prob[80][1200];
    straw_pplus_lib()
    {
      std::ifstream MSlibrary;
      int j,k;
      double prob,msNcount[80][1200],msN[80];
      char *filein[] = {"/afs/cern.ch/na48/user/ruggierg/geant4/mslibrary/pionplus_500.db",
                        "/afs/cern.ch/na48/user/ruggierg/geant4/mslibrary/pionplus_1500.db",
                        "/afs/cern.ch/na48/user/ruggierg/geant4/mslibrary/pionplus_2500.db",
                        "/afs/cern.ch/na48/user/ruggierg/geant4/mslibrary/pionplus_3500.db",
                        "/afs/cern.ch/na48/user/ruggierg/geant4/mslibrary/pionplus_4500.db",
                        "/afs/cern.ch/na48/user/ruggierg/geant4/mslibrary/pionplus_5500.db",
                        "/afs/cern.ch/na48/user/ruggierg/geant4/mslibrary/pionplus_6500.db",
                        "/afs/cern.ch/na48/user/ruggierg/geant4/mslibrary/pionplus_7500.db",
                        "/afs/cern.ch/na48/user/ruggierg/geant4/mslibrary/pionplus_8500.db",
                        "/afs/cern.ch/na48/user/ruggierg/geant4/mslibrary/pionplus_9500.db",
                        "/afs/cern.ch/na48/user/ruggierg/geant4/mslibrary/pionplus_10500.db",
                        "/afs/cern.ch/na48/user/ruggierg/geant4/mslibrary/pionplus_11500.db",
                        "/afs/cern.ch/na48/user/ruggierg/geant4/mslibrary/pionplus_12500.db",
                        "/afs/cern.ch/na48/user/ruggierg/geant4/mslibrary/pionplus_13500.db",
                        "/afs/cern.ch/na48/user/ruggierg/geant4/mslibrary/pionplus_14500.db",
                        "/afs/cern.ch/na48/user/ruggierg/geant4/mslibrary/pionplus_15500.db",
                        "/afs/cern.ch/na48/user/ruggierg/geant4/mslibrary/pionplus_16500.db",
                        "/afs/cern.ch/na48/user/ruggierg/geant4/mslibrary/pionplus_17500.db",
                        "/afs/cern.ch/na48/user/ruggierg/geant4/mslibrary/pionplus_18500.db",
                        "/afs/cern.ch/na48/user/ruggierg/geant4/mslibrary/pionplus_19500.db",
                        "/afs/cern.ch/na48/user/ruggierg/geant4/mslibrary/pionplus_20500.db",
                        "/afs/cern.ch/na48/user/ruggierg/geant4/mslibrary/pionplus_21500.db",
                        "/afs/cern.ch/na48/user/ruggierg/geant4/mslibrary/pionplus_22500.db",
                        "/afs/cern.ch/na48/user/ruggierg/geant4/mslibrary/pionplus_23500.db",
                        "/afs/cern.ch/na48/user/ruggierg/geant4/mslibrary/pionplus_24500.db",
                        "/afs/cern.ch/na48/user/ruggierg/geant4/mslibrary/pionplus_25500.db",
                        "/afs/cern.ch/na48/user/ruggierg/geant4/mslibrary/pionplus_26500.db",
                        "/afs/cern.ch/na48/user/ruggierg/geant4/mslibrary/pionplus_27500.db",
                        "/afs/cern.ch/na48/user/ruggierg/geant4/mslibrary/pionplus_28500.db",
                        "/afs/cern.ch/na48/user/ruggierg/geant4/mslibrary/pionplus_29500.db",
                        "/afs/cern.ch/na48/user/ruggierg/geant4/mslibrary/pionplus_30500.db",
                        "/afs/cern.ch/na48/user/ruggierg/geant4/mslibrary/pionplus_31500.db",
                        "/afs/cern.ch/na48/user/ruggierg/geant4/mslibrary/pionplus_32500.db",
                        "/afs/cern.ch/na48/user/ruggierg/geant4/mslibrary/pionplus_33500.db",
                        "/afs/cern.ch/na48/user/ruggierg/geant4/mslibrary/pionplus_34500.db",
                        "/afs/cern.ch/na48/user/ruggierg/geant4/mslibrary/pionplus_35500.db",
                        "/afs/cern.ch/na48/user/ruggierg/geant4/mslibrary/pionplus_36500.db",
                        "/afs/cern.ch/na48/user/ruggierg/geant4/mslibrary/pionplus_37500.db",
                        "/afs/cern.ch/na48/user/ruggierg/geant4/mslibrary/pionplus_38500.db",
                        "/afs/cern.ch/na48/user/ruggierg/geant4/mslibrary/pionplus_39500.db",
                        "/afs/cern.ch/na48/user/ruggierg/geant4/mslibrary/pionplus_40500.db",
                        "/afs/cern.ch/na48/user/ruggierg/geant4/mslibrary/pionplus_41500.db",
                        "/afs/cern.ch/na48/user/ruggierg/geant4/mslibrary/pionplus_42500.db",
                        "/afs/cern.ch/na48/user/ruggierg/geant4/mslibrary/pionplus_43500.db",
                        "/afs/cern.ch/na48/user/ruggierg/geant4/mslibrary/pionplus_44500.db",
                        "/afs/cern.ch/na48/user/ruggierg/geant4/mslibrary/pionplus_45500.db",
                        "/afs/cern.ch/na48/user/ruggierg/geant4/mslibrary/pionplus_46500.db",
                        "/afs/cern.ch/na48/user/ruggierg/geant4/mslibrary/pionplus_47500.db",
                        "/afs/cern.ch/na48/user/ruggierg/geant4/mslibrary/pionplus_48500.db",
                        "/afs/cern.ch/na48/user/ruggierg/geant4/mslibrary/pionplus_49500.db",
                        "/afs/cern.ch/na48/user/ruggierg/geant4/mslibrary/pionplus_50500.db",
                        "/afs/cern.ch/na48/user/ruggierg/geant4/mslibrary/pionplus_51500.db",
                        "/afs/cern.ch/na48/user/ruggierg/geant4/mslibrary/pionplus_52500.db",
                        "/afs/cern.ch/na48/user/ruggierg/geant4/mslibrary/pionplus_53500.db",
                        "/afs/cern.ch/na48/user/ruggierg/geant4/mslibrary/pionplus_54500.db",
                        "/afs/cern.ch/na48/user/ruggierg/geant4/mslibrary/pionplus_55500.db",
                        "/afs/cern.ch/na48/user/ruggierg/geant4/mslibrary/pionplus_56500.db",
                        "/afs/cern.ch/na48/user/ruggierg/geant4/mslibrary/pionplus_57500.db",
                        "/afs/cern.ch/na48/user/ruggierg/geant4/mslibrary/pionplus_58500.db",
                        "/afs/cern.ch/na48/user/ruggierg/geant4/mslibrary/pionplus_59500.db",
                        "/afs/cern.ch/na48/user/ruggierg/geant4/mslibrary/pionplus_60500.db",
                        "/afs/cern.ch/na48/user/ruggierg/geant4/mslibrary/pionplus_61500.db",
                        "/afs/cern.ch/na48/user/ruggierg/geant4/mslibrary/pionplus_62500.db",
                        "/afs/cern.ch/na48/user/ruggierg/geant4/mslibrary/pionplus_63500.db",
                        "/afs/cern.ch/na48/user/ruggierg/geant4/mslibrary/pionplus_64500.db",
                        "/afs/cern.ch/na48/user/ruggierg/geant4/mslibrary/pionplus_65500.db",
                        "/afs/cern.ch/na48/user/ruggierg/geant4/mslibrary/pionplus_66500.db",
                        "/afs/cern.ch/na48/user/ruggierg/geant4/mslibrary/pionplus_67500.db",
                        "/afs/cern.ch/na48/user/ruggierg/geant4/mslibrary/pionplus_68500.db",
                        "/afs/cern.ch/na48/user/ruggierg/geant4/mslibrary/pionplus_69500.db",
                        "/afs/cern.ch/na48/user/ruggierg/geant4/mslibrary/pionplus_70500.db",
                        "/afs/cern.ch/na48/user/ruggierg/geant4/mslibrary/pionplus_71500.db",
                        "/afs/cern.ch/na48/user/ruggierg/geant4/mslibrary/pionplus_72500.db",
                        "/afs/cern.ch/na48/user/ruggierg/geant4/mslibrary/pionplus_73500.db",
                        "/afs/cern.ch/na48/user/ruggierg/geant4/mslibrary/pionplus_74500.db",
                        "/afs/cern.ch/na48/user/ruggierg/geant4/mslibrary/pionplus_75500.db",
                        "/afs/cern.ch/na48/user/ruggierg/geant4/mslibrary/pionplus_76500.db",
                        "/afs/cern.ch/na48/user/ruggierg/geant4/mslibrary/pionplus_77500.db",
                        "/afs/cern.ch/na48/user/ruggierg/geant4/mslibrary/pionplus_78500.db",
                        "/afs/cern.ch/na48/user/ruggierg/geant4/mslibrary/pionplus_79500.db"};
      for (j=0;j<80;j++)
      {
        msN[j] = 0;
        MSlibrary.open(filein[j],ios::in);
        for (k=0;k<1200;k++)
        {
          MSlibrary >> Theta[k] >> msNcount[j][k];
          msN[j] += msNcount[j][k];
        }
        MSlibrary.close();
      }
      for (j=0;j<80;j++)
      {
        prob = 0;
        if (!msN[j]) continue;
        for (k=0;k<1200;k++)
        {
          Prob[j][1199-k] = 1.-prob;
          prob += msNcount[j][1199-k]/msN[j];
        }
      }
      cout << "Pion+ MS library for Straw Chambers Loaded" << endl;
    }
   ~straw_pplus_lib(){}
};
